{
   NSIS Pascal Plugin Test.
   Call using:
   Pascal::ScriptFile "Test.pas"
}

type
  { Define type alias }
  HWND = Cardinal;
  HINST = Cardinal;
  DWORD = Cardinal;

const
  SW_NORMAL = 1;
  MAX_PATH = 260;

{ Syntax for import functions: prototype external 'functionname@library.dll callingconvention' }
function SetWindowText(hWnd: HWND; lpString: String): Boolean; external 'SetWindowTextA@user32.dll stdcall';
function ShellExecute(hWnd: HWND; Operation, FileName, Parameters,
  Directory: String; ShowCmd: Integer): HINST; external 'ShellExecuteA@shell32.dll stdcall';
function DeleteFile(lpFileName: String): Boolean; external 'DeleteFileA@kernel32.dll stdcall';
procedure Sleep(dwMilliseconds: DWORD); external 'Sleep@kernel32.dll stdcall';
function GetTempPath(nBufferLength: DWORD; lpBuffer: String): DWORD; external 'GetTempPathA@kernel32.dll stdcall';

procedure PrintVariables;
var
  VarNames: array of String;
  VarCount: TVariableList;
begin
  VarNames := ['$0', '$1','$2','$3','$4','$5','$6','$7','$8','$9', '$R0',
     '$R1','$R2','$R3', '$R4','$R5','$R6','$R7','$R8','$R9','$CMDLINE','$INSTDIR',
     '$OUTDIR','$EXEDIR','$LANGUAGE'];

  for VarCount := INST_0 to INST_LANG do
    DetailPrint('Pascal: ' + VarNames[VarCount] + '=' + GetUserVariable(VarCount));
end;

var
  TempFileName, S: String;
  FileStream: TFileStream;
begin
  SetWindowText(hwndParent, 'Caption changed from the Pascal script using imported SetWindowText function!');

  if Pop(S) then
    MessageBox(S, 'Pascal MessageBox', MB_OK or MB_ICONINFORMATION)
  else
    MessageBox('Empty stack!', 'Pascal MessageBox', MB_OK or MB_ICONHAND);

  if MessageBox('Do you want to check the values of all NSIS variables?',
    'Print NSIS Variables', MB_YESNO or MB_ICONQUESTION) = IDYES then PrintVariables;

  Push('Push form Pascal script');
  SetUserVariable(INST_R6, 'New value of $R6');

  { Get temp file name }
  SetLength(TempFileName, MAX_PATH);
  SetLength(TempFileName, GetTempPath(MAX_PATH, TempFileName));
  TempFileName := TempFileName + 'PascalStreamTest.txt'

  { Stream test }
  FileStream := TFileStream.Create(TempFileName, fmCreate);
  try
    S := 'File (' + TempFileName + ') write from the script engine'#13#10;
    S := S + 'The value of $R6 is "' + GetUserVariable(INST_R6) + '"';
    FileStream.Write(S, Length(S));
  finally
    FileStream.Free;
  end;

  ShellExecute(hwndParent, 'open', TempFileName, '', '', SW_NORMAL);
  Sleep(500); { Wait a little }
  DeleteFile(TempFileName);
end.
